// IG-11 Nurse Droid Head Neopixels
//John Guarnero 2020
//Code just bit bangs pixels.  Nothing Fancy here.


#include <Adafruit_NeoPixel.h>

//Define Arduino Pins to control NeoPixels
#define Pin_Head        4 //Pin 4 is the string of pixels for the holes in the head
#define Pin_Detonator   5 //Pin 5 is the detonator
#define Pin_LEye        6 //Pin 6 is the left eye
#define Pin_REye        7 //Pin 7 is the right eye
#define Pin_Tube        8 //Pin 8 is the long tube
#define Pin_Short_Tube  9 //Pin 9 is the short tune

// Number of NeoPixels attached to each pin
#define NumPixels_Head 14       //Neopixel Dots Strand 20 Neopixels (were only using 9 of them)
#define NumPixels_LEye 1        //Neopixel Mini Button 1 Neopixel
#define NumPixels_REye 1        //Neopixel Mini Button 1 Neopixel
#define NumPixels_Tube 1        //Neopixel Mini Button 1 Neopixel
#define NumPixels_Short_Tube 1  //Neopixel Mini Button 1 Neopixel
#define NumPixels_Detonator 7   //Neopixel Jewel 7 Neopixel


// When setting up the NeoPixel library, we tell it how many pixels,
// and which pin to use to send signals.
Adafruit_NeoPixel Detonator(NumPixels_Detonator, Pin_Detonator, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Head(NumPixels_Head, Pin_Head, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Left_Eye(NumPixels_LEye, Pin_LEye, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Right_Eye(NumPixels_REye, Pin_REye, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Tube(NumPixels_Tube, Pin_Tube, NEO_GRB + NEO_KHZ800);
Adafruit_NeoPixel Short_Tube(NumPixels_Short_Tube, Pin_Short_Tube, NEO_GRB + NEO_KHZ800);

#define DELAYVAL 50 // Time (in milliseconds) to pause between pixel color changes.  Modify Higher to slow down and lower to speed up.

//Define Variables used in the program
int Detonator_Pixel = 0;
int Eye_Pixels = 0;
int Eye_Fade_Up = 1;
int Eye_Fade_Down = 0;
int Change_Color = 0;
long RandomRed;
long RandomGreen;
long RandomBlue;

//Required to inititialize NeoPixels
void setup() 
{
 Head.begin(); 
 Head.clear(); 
 Detonator.begin(); 
 Detonator.clear(); 
 Left_Eye.begin(); 
 Left_Eye.clear(); 
 Right_Eye.begin(); 
 Right_Eye.clear(); 
 Tube.begin(); 
 Tube.clear(); 
 Short_Tube.begin(); 
 Short_Tube.clear(); 
}

//Program runs code below - Void Loop
void loop()
{

  // The first NeoPixel is always #0, second is 1, all the way up
  // to the count of pixels minus one.
  //The head has a total of 13 NeoPixels used in the strand.

 // This for loop will cycle between 0 and 13 (We are using 13 of the 9 NeoPixels required for the head
 // here are 20 NeoPixels in the strand and we will remove the last 7 by cutting the strand
 // We need 13 of the NeoPixels since they are wired in 4 inch increments and we need to skip the ones 
 // 5, 8, 10 and 12 since they dont reach the holes.  We just leave them in the string since they do not
 //take away from the effect.
 
 for (int i = 0; i < 13; i++) {
  //Give Eeach pixel a baseline (red with brightness of 25

  Head.setPixelColor(0, Head.Color(25, 0, 0));
  Head.setPixelColor(1, Head.Color(25, 0, 0));
  Head.setPixelColor(2, Head.Color(25, 0, 0));    
  Head.setPixelColor(3, Head.Color(25, 0, 0));
  Head.setPixelColor(4, Head.Color(25, 0, 0));
  Head.setPixelColor(5, Head.Color(25, 0, 0));
  Head.setPixelColor(6, Head.Color(25, 0, 0));
  Head.setPixelColor(7, Head.Color(25, 0, 0));
  Head.setPixelColor(8, Head.Color(25, 0, 0));          
  Head.setPixelColor(9, Head.Color(25, 0, 0));
  Head.setPixelColor(10, Head.Color(25, 0, 0));
  Head.setPixelColor(11, Head.Color(25, 0, 0));
  Head.setPixelColor(12, Head.Color(25, 0, 0));
           

  //Based on the for loop count, make previous pixels dimmer 

  Head.setPixelColor(i-7, Head.Color(36, 0, 0));  
  Head.setPixelColor(i-6, Head.Color(40, 0, 0));  
  Head.setPixelColor(i-5, Head.Color(50, 0, 0));
  Head.setPixelColor(i-4, Head.Color(70, 0, 0));
  Head.setPixelColor(i-3, Head.Color(90, 0, 0));
  Head.setPixelColor(i-2, Head.Color(110, 0, 0));
  Head.setPixelColor(i-1, Head.Color(140, 0, 0));
  Head.setPixelColor(i, Head.Color(255, 0, 0));
  // .show updates all pixels for the head at once   
  Head.show(); 
  //delay the for loop incrementing by the millisecond DELAYVAL
  delay (DELAYVAL);


//Fade Eyes Up and Down

//Red Color
//Red Color Fade Up
 if (Eye_Fade_Up == 1) {
  Eye_Pixels = Eye_Pixels + 5;
  if (Eye_Pixels > 250) {
  Eye_Fade_Up = 0;
  Eye_Fade_Down = 1;
  } //IF statement end bracket
  } //IF statement end bracket
  
//Red Color Fade Down
if (Eye_Fade_Down == 1) {
  Eye_Pixels = Eye_Pixels - 15;
  if (Eye_Pixels < 25) {
  Eye_Fade_Up = 1;
  Eye_Fade_Down = 0;
  } //IF statement end bracket
  } //IF statement end bracket
   Left_Eye.setPixelColor(0, Left_Eye.Color(0, 0, Eye_Pixels));   //If you want to change the color it (Red, Green, Blue) --> .Color (R, G, B) 
   Right_Eye.setPixelColor(0, Right_Eye.Color(0, 0, Eye_Pixels)); //If you want to change the color it (Red, Green, Blue) --> .Color (R, G, B) 

    //Update NeoPixels
   Left_Eye.show();  //Update the Left Eye NeoPixel
   Right_Eye.show(); //Update the Left Eye NeoPixel


  //The tubes uses a single NeoPixel.  The code below randomizes the colors shown for the tube.
  //Since the NeoPixel sitds farther back in the tube, the color brightness for Red and Blue are 
  //near maximum intensity so the NeoPixel color can be seen (250).
  RandomRed = random(1);
  RandomGreen = random(1);
  RandomBlue = random(250);
  Tube.setPixelColor(0, Tube.Color(RandomRed,RandomGreen, RandomBlue)); //The Long Tube just flashed random colors 
  Tube.show(); 
  RandomRed = random(250);
  RandomGreen = random(1);
  RandomBlue = random(1);
  Short_Tube.setPixelColor(0, Short_Tube.Color(RandomRed,RandomGreen, RandomBlue)); //The Short Tube just flashed random colors 
  Short_Tube.show();
 
 //Control the Detonator Jewel NeoPixels every DELAYVAL
 // Detonator.setPixelColor(0, Detonator.Color(0, 0, 0));

  Detonator.setPixelColor(Detonator_Pixel - 6, Detonator.Color(1, 0, 1));
  Detonator.setPixelColor(Detonator_Pixel - 5, Detonator.Color(5, 0, 2));
  Detonator.setPixelColor(Detonator_Pixel - 4, Detonator.Color(5, 5, 0));
  Detonator.setPixelColor(Detonator_Pixel - 3, Detonator.Color(0, 0, 10));
  Detonator.setPixelColor(Detonator_Pixel - 2, Detonator.Color(5, 5, 8));
  Detonator.setPixelColor(Detonator_Pixel - 1, Detonator.Color(5, 0, 6));
  Detonator.setPixelColor(Detonator_Pixel, Detonator.Color(150, 0, 0)); // The Red moving dot intensity is 150 (middle upper range)
  Detonator.show(); 
  //A Jewel has 7 pixels so count 0 to 6 and the code below cycles the red dot from NeoPixel to NeoPixel every DELAYVAL.
  //This provides a pulsating effect for the Detonator.
  Detonator_Pixel = Detonator_Pixel + 1;
  if (Detonator_Pixel > 7) {
  Detonator_Pixel = 0;
  
  } //IF statement end bracket
  } //For statement end bracket 
 
  } // End of Program Void Loop end bracket

 





  
  
  
  
  
 
